openlink/core/urls.py
from django.urls import path, register_converter
from openlink.core import views
from openlink.core.views import items, mapping, projects, publish, tools, users


class FloatConverter:
    regex = r"[\d\.\d]+"

    def to_python(self, value):
        return float(value)

    def to_url(self, value):
        return "{}".format(value)


register_converter(FloatConverter, "float")


app_name = "core"
urlpatterns = [
    path("", projects.projects, name="home"),
    path("about/", views.home, name="about"),
    path("profile/<username>/", views.get_user_profile, name="user-profile"),
    path("contact/", views.contact, name="contact"),
    # projects creation
    path("projects", projects.projects, name="projects"),
    path("projects/new", projects.new_project, name="projects-new"),
    path("projects/add", projects.add_project, name="projects-add"),
    # projects tools
    path(
        "projects/<int:project_id>/tools",
        tools.list_tools_project,
        name="tools-project",
    ),
    path(
        "projects/<int:project_id>/tools/new",
        tools.select_connector_project,
        name="select-connector-project",
    ),
    path(
        "projects/<int:project_id>/tools/<str:connector>",
        tools.add_tool_project,
        name="add-tool-project",
    ),
    path(
        "projects/<int:project_id>/tools/<int:tool_id>/edit_tool",
        tools.ToolUpdate.as_view(),
        name="tools-edit-project",
    ),
    path(
        "projects/<int:project_id>/tool/<int:tool_id>",
        tools.get_tool_info_project,
        name="tool-project",
    ),
    path(
        "projects/<int:project_id>/delete/tool/<int:pk>",
        tools.delete_tool,
        name="delete_tool",
    ),
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    # projects editing
    path(
        "projects/<int:project_id>/edit",
        items.ProjectUpdate.as_view(),
        name="edit-project",
    ),
    path(
        "projects/<int:project_id>/add_user_mapping",
        users.add_user_mapping,
        name="add_user_mapping",
    ),
    path(
        "projects/<int:project_id>/manage_user",
        mapping.mapping_project_user,
        name="mapping_project_user",
    ),
    path(
        "projects/<int:project_id>/delete_user_mapping/<str:pk>",
        mapping.delete_user_mapping,
        name="delete_user_mapping",
    ),
    path("projects/<int:project_id>/", projects.details, name="projects-details"),
    path(
        "projects/<int:project_id>/delete/<str:data_type>/<int:pk>",
        projects.delete,
        name="delete",
    ),
    path(
        "projects/<int:project_id>/add_investigation",
        items.add_investigation,
        name="add-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/edit",
        items.InvestigationUpdate.as_view(),
        name="edit-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/add_study",
        items.add_study,
        name="add-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/edit",
        items.StudyUpdate.as_view(),
        name="edit-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/add_assay",
        items.add_assay,
        name="add-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/edit",
        items.AssayUpdate.as_view(),
        name="edit-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/add_data",
        items.add_data,
        name="add-data",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/edit",
        items.DataUpdate.as_view(),
        name="edit-data",
    ),
    # project investigation map_id item
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/datasets",
    #     mapping.datasets,
    #     name="datasets",
    # ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/studies",
        mapping.studies,
        name="studies",
    ),
    # project investigation map_id select mapping
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/select_data_mapping",
        mapping.select_data_mapping,
        name="select_data_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/select_assay_mapping",
        mapping.select_assay_mapping,
        name="select_assay_mapping",
    ),
    # publish
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # testé quelle route est uttilisé pour choose_meta
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_non_linked_object",
    #     mapping.choose_non_linked_object,
    #     name="choose_non_linked_object",
    # ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(

openlink/urls.py
import debug_toolbar

# from openlink.core.admin import admin_site
from django.contrib import admin
from django.contrib.auth import views
from django.urls import include, path
from rest_framework import routers

from openlink import log_manager
from openlink.core.views import api

admin.site.site_header = "OPENLINK Database administration"
admin.site.site_title = "OPENLINK administration"
admin.site.index_title = "OPENLINK Site Administration"

router = routers.DefaultRouter()
router.register(r"taskinfo", api.TaskinfoViewSet, basename="taskinfo")
router.register(r"access_mapping", api.MappingViewSet, basename="access_mapping")

urlpatterns = [
    path("__debug__/", include(debug_toolbar.urls)),
    path("", include("openlink.core.urls")),
    path("admin/", admin.site.urls),
    path("accounts/login/", log_manager.login_page, name="login"),
    path("accounts/logout/", log_manager.custom_logout, name="logout"),
    path("accounts/", include("django.contrib.auth.urls")),
    path("django-rq/", include("django_rq.urls")),
    path("oidc/", include("mozilla_django_oidc.urls")),
    path("api/", include(router.urls)),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
]

openlink/core/views/api.py
import datetime
import json
import logging

from django.db.models import Q
from django.http import JsonResponse
from openlink.core.models import Mapping, TaskInfo
from openlink.core.serializers import TaskinfoSerializer
from rest_framework import permissions, viewsets


class TaskinfoViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = TaskInfo.objects.all()
    serializer_class = TaskinfoSerializer

    def get_queryset(self):
        queryset = TaskInfo.objects.all()
        project_id = None
        max_lenght = None
        delta_minutes = None
        if self.request.query_params.get("project_id"):
            project_id = int(self.request.query_params.get("project_id"))
        if self.request.query_params.get("max_lenght"):
            max_lenght = int(self.request.query_params.get("max_lenght"))
        if self.request.query_params.get("delta_minutes"):
            delta_minutes = int(self.request.query_params.get("delta_minutes"))
        if project_id is not None:
            queryset = queryset.filter(project__id=project_id)
        if delta_minutes is not None:
            creation_time = datetime.datetime.now() - datetime.timedelta(
                minutes=delta_minutes
            )
            queryset = queryset.filter(
                Q(start_date__gte=creation_time)
                | Q(status="queued")
                | Q(status="started")
            )
        if max_lenght is not None:
            queryset = queryset.order_by("-start_date")[:max_lenght]
        return queryset


class MappingViewSet(viewsets.ViewSet):
    def list(self, request):
        mapping_id = self.request.query_params.get("item_id")
        res = mapping_id.strip("][").split(", ")
        all_results = {}
        list_result = []
        for obj in res:
            dict = {}
            try:
                mapping_object = Mapping.objects.filter(
                    foreign_id_obj__id=obj, type="data"
                )
            except Exception as e:
                logging.debug(e)
                continue
            if mapping_object:
                connector = mapping_object[0].tool_id.get_connector(
                    self.request.session["vault_token"]
                )
                has_access = connector.check_file_access(mapping_object[0].object_id)
                dict["id"] = mapping_object[0].id
                dict["access"] = has_access
                list_result.append(dict)

        all_results["results"] = list_result
        data = json.dumps(all_results)
        return JsonResponse(data, safe=False)

openlink/core/views/users.py
import logging

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from mozilla_django_oidc.auth import OIDCAuthenticationBackend
from openlink.core.forms import AddProjectUserForm
from openlink.core.models import MappingProjectUser, Project

logger = logging.getLogger(__name__)


class OpenLinkOIDCAuthenticationBackend(OIDCAuthenticationBackend):
    def create_user(self, claims):
        user = super(OpenLinkOIDCAuthenticationBackend, self).create_user(claims)
        user.username = claims.get("preferred_username", "")
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user

    def update_user(self, user, claims):
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user


@login_required
def get_access_level(request, project_id):
    # return current user access level for a given project
    access_level = ""
    user = request.user
    try:
        projects_list_user = Project.objects.get(
            author__user=request.user, id=project_id
        )
    except Project.DoesNotExist:
        projects_list_user = None
    if projects_list_user:
        access_level = str("administrator")
    proj_map = (
        MappingProjectUser.objects.filter(user__user=user)
        .filter(project__id=project_id)
        .values()
    )
    if proj_map.exists():
        for value in proj_map:
            access_level = value["role"]
    return access_level


@login_required
def add_user_mapping(request, *args, **kwargs):
    # Select a user to be map to the current project
    current_user = request.user
    current_proj = kwargs["project_id"]
    data_type = "project"
    mpu_list = MappingProjectUser.objects.filter(project__id=current_proj)
    project = get_object_or_404(Project, id=current_proj)

    if request.method == "POST":
        form = AddProjectUserForm(request.POST)
        user_mapping = form.save(commit=False)
        user_mapping.name = str(current_proj) + "_" + str(form.cleaned_data.get("user"))
        user_mapping.project = project
        user_mapping.save()
        messages.info(request, "User " + str(form.cleaned_data.get("user")) + " added")

        return HttpResponseRedirect(
            reverse("core:add_user_mapping", args=[current_proj])
        )

    else:
        form = AddProjectUserForm()

    return render(
        request,
        "mapping/add_user_mapping.html",
        {
            "form": form,
            "current_proj": current_proj,
            "data_type": data_type,
            "current_user": current_user,
            "data_type": data_type,
            "mpu_list": mpu_list,
            "project": project,
        },
    )

openlink/core/templates/item_update/assay_update_form.html
{% load guardian_tags %}
{% load widget_tweaks %}
{% load url_link %}
{% load is_publisher %}
{% load plurals_type %}
{% load crispy_forms_tags %}
{% load has_access_url %}

{% block content %}
<a class="add-link btn btn-primary"
    href="{% url 'core:choose_tool_project' project.id investigation.id data_type item.id %}">Add
    Link</a>
</div>
</div>
</br>

<section>

    <table id="table" class="table table-striped table-bordered table-hover">

        <thead>
            <tr>
                <th>Name</th>
                <th>Tool</th>
                <th>Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for mapping in mappings %}
            {% if not mapping.0.tool_id|is_publisher %}
            <tr>
                <td><i class="fa fa-flask fa-1x experiment ic-w mx-1 "></i><a href="{{mapping.0.link_url}}"
                        target="_blank">{{mapping.0.name}}</a></td>
                <td>{{mapping.0.link_tool}}</td>
                <td>
                    <div class="btn-group">
                        <div class="btn-group">
                            {% if mapping.0.tool_id|has_access_url %}
                            <a type="button" style="margin-right:0; margin-left: 10px;"
                                class="btn-sm btn rounded btn-secondary" role=button href="{{mapping.0.link_url}}"
                                target="_blank">View on {{mapping.0.link_tool}}</a>
                            {% endif %}
                        </div>
                        {% for key, values in mapping.1.items %}
                        {% if key == "datas" %}
                        <a type="button" style="margin-right:0; margin-left: 10px;"
                            class="btn-sm btn rounded btn-secondary"
                            href='{% url 'core:datas'  project_id=project.id investigation_id=investigation.id assay_id=item.id tool_id=mapping.0.tool_id.id map_id=mapping.0.object_id %}'>Link
                            {% for key, values in mapping.1.items %}
                            {% if key == "assays" %}
                            {% for value in values %}{{value}}{% if not forloop.last %} &{% endif %}{% endfor %}
                            {% endif %}
                            {% endfor %}
                            content as new data</a>
                        {% endif %}
                        {% endfor %}
                        <a type="button" style="margin-right:0; margin-left: 10px;"
                            class="btn-sm btn rounded btn-danger" role=button
                            href='{% url 'core:delete-mapping' project_id=project.id investigation_id=investigation.id data_type="assay" pk=mapping.0.id  %}'><i
                                class="fa fa-trash-alt fa-1x"></i></a>
                </td>
                </div>
            </tr>
            {% endif %}
            {% endfor %}
        </tbody>
    </table>
</section>

<br><br>
<div class="row">
    <div class="col-sm-6">
        <span class="badge badge-pill badge-secondary">{{ nb_publisher }}</span>
        <span class="texte-badge"> publication found</span>
    </div>
</div>
<section>

    <table id="table" class="table table-striped table-bordered table-hover">

        <thead>
            <tr>
                <th>Name</th>
                <th>DOI</th>
                <th>Tool</th>
                <th>Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for mapping in mappings %}
            {% if mapping.0.tool_id|is_publisher %}
            <tr>
                <td><i class="fa fa-laptop fa-1x laptop ic-w mx-1"></i><a href="{{mapping.0.link_url}}"
                        target="_blank">{{mapping.0.name}}</a></td>
                <td>{{mapping.0.object_id}}</td>
                <td>{{mapping.0.link_tool}}</td>

                <td>
                    <div class="btn-group">
                        <div class="btn-group">
                            <a type="button" style="margin-right:0; margin-left: 10px;"
                                class="btn-sm btn rounded btn-secondary" role=button href="{{mapping.0.link_url}}"
                                target="_blank">View on {{mapping.0.link_tool}}</a>
                        </div>
                    </div>
                    <a type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-danger"
                        role=button
                        href='{% url 'core:delete-mapping' project_id=project.id investigation_id=investigation.id data_type="investigation" pk=mapping.0.id  %}'>
                        <i class="fa fa-trash-alt fa-1x"></i></a>
                    </div>
                    </div>
            </tr>
            {% endif %}
            {% endfor %}
        </tbody>
    </table>

</section>

<button type="button" class="btn btn-secondary"><a href="{% url 'core:projects-details' project.id %}"> Back
    </a></button>


{% endblock %}

openlink/core/templates/item_update/investigation_update_form.html
{% load guardian_tags %}
{% load widget_tweaks %}
{% load url_link %}
{% load dict %}
{% load is_publisher %}
{% load crispy_forms_tags %}
{% load plurals_type %}
{% load has_access_url %}
{% block content %}
{% get_obj_perms request.user for project as "project_perms" %}
{% if "change_project" in project_perms %}
<a id="link_card" style="margin-bottom: 5px;" class="btn btn-primary"
    href="{% url 'core:choose_tool_project' project.id data_type item.id %}">Add Link</a>
{% else %}
<div id="link_card" class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover" data-placement="right"
    title="Action not available" data-container="body" data-html="true"
    data-content="You don't have sufficient permissions to  <br/> <strong>Add Link</strong>.">
    <button class="add-link btn btn-primary " type="button" disabled>Add link</button>
</div>
{% endif %}
</div>
</div>
</br>
<section>

    <table id="table" class="table table-striped table-bordered table-hover">

        <thead>
            <tr>
                <th>Name</th>
                <th>Tool</th>
                <th>Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for mapping in mappings %}
            {% if not mapping.0.tool_id|is_publisher %}
            <tr>
                <td><i class="fa fa-laptop fa-1x laptop ic-w mx-1"></i><a href="{{mapping.0.link_url}}"
                        target="_blank">{{mapping.0.name}}</a></td>
                <td>{{mapping.0.link_tool}}</td>
                <td>
                    <div class="btn-group">
                        <div class="btn-group">
                            {% if mapping.0.tool_id|has_access_url %}
                            <a type="button" style="margin-right:0; margin-left: 10px;"
                                class="btn-sm btn rounded btn-secondary" role=button href="{{mapping.0.link_url}}"
                                target="_blank">View on {{mapping.0.link_tool}}</a>
                            {% endif %}
                        </div>

                        <button type="button" style="margin-left: 10px;border:0px"
                            class="btn-sm dropdown-toggle dropdown-toggle-split btn-secondary" data-toggle="dropdown"
                            aria-haspopup="true" aria-expanded="false">Add & Link
                        </button>


                        <div class="dropdown-menu {{key|lower}}" aria-labelledby="dropdownMenuLink">
                            {% for key, values in mapping.1.items %}
                            <a class="dropdown-item "
                                href='{% url 'core:'|add:key  project_id=project.id investigation_id=investigation.id tool_id=mapping.0.tool_id.id map_id=mapping.0.object_id %}'> {{mapping.0.link_tool|lower}}
                                {% for value in values %}{{value}}{% if not forloop.last %} &{% endif %}{% endfor %}</a>
                            {% endfor %}
                        </div>
                        <a type="button" style="margin-right:0; margin-left: 10px;"
                            class="btn-sm btn rounded btn-danger" role=button
                            href='{% url 'core:delete-mapping' project_id=project.id investigation_id=investigation.id data_type="investigation" pk=mapping.0.id  %}'>
                            <i class="fa fa-trash-alt fa-1x"></i></a>
                    </div>
                    </div>
            </tr>
            {% endif %}
            {% endfor %}
        </tbody>
    </table>

</section>

<br><br>
<div class="row">
    <div class="col-sm-6">
        <span class="badge badge-pill badge-secondary">{{ nb_publisher }}</span>
        <span class="texte-badge"> publication found</span>
    </div>
    <div class="col-sm-6 text-right">
        <a style="margin-bottom: 5px;" class="btn btn-info"
            href="{% url 'core:choose_tool_for_publish_project' project.id data_type item.id %}">Publish</a>
    </div>
</div>
<section>

    <table id="table" class="table table-striped table-bordered table-hover">

        <thead>
            <tr>
                <th>Name</th>
                <th>DOI</th>
                <th>Tool</th>
                <th>Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for mapping in mappings %}
            {% if mapping.0.tool_id|is_publisher %}
            <tr>
                <td><i class="fa fa-laptop fa-1x laptop ic-w mx-1"></i><a href="{{mapping.0.link_url}}"
                        target="_blank">{{mapping.0.name}}</a></td>
                <td>{{mapping.0.object_id}}</td>
                <td>{{mapping.0.link_tool}}</td>

                <td>
                    <div class="btn-group">
                        <div class="btn-group">
                            <a type="button" style="margin-right:0; margin-left: 10px;"
                                class="btn-sm btn rounded btn-secondary" role=button href="{{mapping.0.link_url}}"
                                target="_blank">View on {{mapping.0.link_tool}}</a>
                        </div>
                        <a type="button" style="margin-right:0; margin-left: 10px;"
                            class="btn-sm btn rounded btn-secondary" role=button target="_blank"
                            href='{% url 'core:choose_object_to_publish' project.id data_type investigation.id mapping.0.link_tool mapping.0.tool_id.id mapping.0.object_id %}'>
                            Update depository</a>
                    </div>
                    <a type="button" style="margin-right:0; margin-left: 10px;" class="btn-sm btn rounded btn-danger"
                        role=button
                        href='{% url 'core:delete-mapping' project_id=project.id investigation_id=investigation.id data_type="investigation" pk=mapping.0.id  %}'>
                        <i class="fa fa-trash-alt fa-1x"></i></a>
                    </div>
                    </div>
            </tr>
            {% endif %}
            {% endfor %}
        </tbody>
    </table>

</section>
<button type="button" class="btn btn-secondary"><a href="{% url 'core:projects-details' project.id %}"> Back
    </a></button>


    <script>
        introJs().setOptions({
            dontShowAgain: true,
            dontShowAgainCookie: "introjs-dontShowAgain3",
            steps: [{
              element: document.getElementById('link_card'),
              title: 'Add links to your investigation!',
              intro: 'Click the "Add Link" button to add a link to your investigation.'
            },{
              element: document.querySelector('.tool_card'),
              title: 'Add tools',
              intro: '⚠️ Be sure to declare at least one tool defore adding a link. <br> Click on the "Manage Tools" if you haven\'t yet'
            }
            ]
          }).start();
    </script>


{% endblock %}

openlink/core/templates/item_update/project_update_form.html
{% extends 'base.html' %}
{% load guardian_tags %}
{% load widget_tweaks %}
{% load url_link %}

{% load crispy_forms_tags %}

{% block content %}

<h4 class="display-titre" style="background-color: rgb(255, 255, 255)">Edit project: {{ name }}</h4>

<form method="post">
    {% csrf_token %}
    {% crispy form %}
    {% get_obj_perms request.user for project as "project_perms" %}
    {% if "change_project" not in project_perms %}
    <div class="form-group">
        <div class="aab col-sm-offset-1 col-sm-2"></div>
        <div class="col-md-8 disabled-button-wrapper" data-toggle="popover" data-trigger="hover" data-placement="right"
            title="Action not available" data-container="body" data-html="true"
            data-content="You don't have sufficient permissions to  <br/> <strong>Edit this project</strong>.">
            <button class="btn btn-primary" type="button" disabled>Update</button>
        </div>
    </div>
    </div>

    {% endif %}
</form>
{% endblock %}